summaryrefslogtreecommitdiffstats
path: root/clients
diff options
context:
space:
mode:
authorMarius Vlad <marius.vlad@collabora.com>2024-11-27 17:47:23 +0200
committerMarius Vlad <marius.vlad@collabora.com>2024-11-27 17:50:54 +0200
commit76a2aada73bc56ade3483b06d49d820a86446430 (patch)
tree00903d714726a0eeed0dc39540b1615260b31e2d /clients
parent57099d32dfa32464563bfba462f37b3a032b1115 (diff)
clients/stream-pipewire-output: Add script to stream PipeWire output
This can be used to automate streaming content from weston's pipewire output. Signed-off-by: Marius Vlad <marius.vlad@collabora.com> Change-Id: I06425217934244cb4d7bbc63bf838b13733721e6
Diffstat (limited to 'clients')
-rwxr-xr-xclients/agl-stream-pipewire-output39
-rw-r--r--clients/meson.build2
2 files changed, 41 insertions, 0 deletions
diff --git a/clients/agl-stream-pipewire-output b/clients/agl-stream-pipewire-output
new file mode 100755
index 0000000..d7ac151
--- /dev/null
+++ b/clients/agl-stream-pipewire-output
@@ -0,0 +1,39 @@
+#!/bin/bash
+# Copyright © 2024 Collabora, Ltd.
+#
+# Permission is hereby granted, free of charge, to any person obtaining
+# a copy of this software and associated documentation files (the
+# "Software"), to deal in the Software without restriction, including
+# without limitation the rights to use, copy, modify, merge, publish,
+# distribute, sublicense, and/or sell copies of the Software, and to
+# permit persons to whom the Software is furnished to do so, subject to
+# the following conditions:
+#
+# The above copyright notice and this permission notice (including the
+# next paragraph) shall be included in all copies or substantial
+# portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
+# BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
+# ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
+# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
+# SOFTWARE.
+
+if [ -z $1 -o -z $2 ]; then
+ echo "$0 host_ip host_port"
+ exit 127
+fi
+
+host=$1
+port=$2
+
+gst-launch-1.0 rtpbin name=rtpbin ! pipewiresrc target-object=weston.pipewire ! videoconvert ! \
+ video/x-raw,format=I420 ! jpegenc ! rtpjpegpay ! \
+ rtpbin.send_rtp_sink_0 rtpbin.send_rtp_src_0 ! \
+ udpsink name=sink host=${host} port=$port rtpbin.send_rtcp_src_0 ! \
+ udpsink host=${host} port=$(($port + 1)) sync=false async=false udpsrc port=$(($port + 2)) ! \
+ rtpbin.recv_rtcp_sink_0
+
diff --git a/clients/meson.build b/clients/meson.build
index e636894..4e0703e 100644
--- a/clients/meson.build
+++ b/clients/meson.build
@@ -37,3 +37,5 @@ foreach t: clients
message('Building client ' + t_name)
endforeach
+
+install_data('agl-stream-pipewire-output', install_dir: get_option('bindir'))